#pragma once

#include <GL/glx.h>

#include <set>
#include <string_view>

#include "forstio/window/gl/gl_context.h"

namespace saw {
struct glx_library_extensions {
public:
	std::string_view raw_extension_string;

	GLXContext (*glXCreateContextAttribsARB)(Display *, GLXFBConfig, GLXContext,
											 Bool, const int *) = nullptr;
};

class xcb_device;
class xcb_gl_context final : public gl_context {
public:
	glx_library_extensions ext_lib;
	own<xcb_device> device;
	int visual_id;
	GLXContext context;
	GLXFBConfig fb_config;

public:
	xcb_gl_context(const glx_library_extensions &, own<xcb_device> &&, int,
				   GLXContext, GLXFBConfig);
	~xcb_gl_context();

	own<gl_window> create_window(const video_mode &, std::string_view) override;

	void flush() override;
};
} // namespace saw
