#pragma once

#include <GL/glx.h>
#include <forstio/common.h>

#include "forstio/window/gl/gl_window.h"

namespace saw {
class xcb_window;
class xcb_gl_context;
class xcb_gl_window final : public gl_window {
public:
	own<xcb_window> window;
	xcb_gl_context &context;

	::GLXWindow glx_window;

public:
	xcb_gl_window(own<xcb_window> &&, xcb_gl_context &, ::GLXWindow);
	~xcb_gl_window();

	void bind() override;
	void swap() override;
	void show() override;
	void hide() override;

	const video_mode &videoMode() const override;
	const std::string_view title() const override;

	void resize(size_t height, size_t width) override;

	conveyor<window::variant_event> onevent() override;
};
} // namespace saw
