#pragma once

#include <forstio/async/async.h>
#include <forstio/common.h>

#include <string_view>
#include <variant>

#include "window.h"

namespace saw {
class device {
public:
	virtual ~device() = default;

	virtual own<window> create_window(const video_mode &mode,
									  std::string_view title_view) = 0;
	virtual void flush() = 0;
};

class io_provider;
own<device> create_device(io_provider &provider);
} // namespace saw
